#include "ijp_net.h"
#include "xjp_net.h"

extern Display *disp;
extern my_window_t main_win;
extern char *XJP_MESSAGE[];
extern char *CARD_FILE;

int xtextSerchList(void *data0,int data1)
{
	PLIST_T *p_head = NULL, *p_tail = NULL;
	PLIST_T *pl;

	char *result;
	int percent;

	if(data0 == NULL) return 0;

	percent = 80;
	pl = (PLIST_T *)data0;
	if(data1 != 0) percent = (int)data1;

	if((result = (char *)xtextInputWindow(disp,&main_win,S_NAME0,S_NAME1,percent)) == NULL)
		return 0;

	if(itextMatchBookList(&p_head,&p_tail,pl,result) < 0){
		xtextSubWindow_Message(disp,main_win,XJP_MESSAGE[17]);
		return 0;
	}

	xtextDispPerson(p_head,80);

	return 0;
}
int xtextDispPerson(void *data0,int data1)
{
	sub_window_t *sn_head = NULL, *sn_tail = NULL;
	PLIST_T *p_head;
	char *result;
	int percent;

	percent = 90;
	p_head = (PLIST_T *)data0;
	if(data1 != 0) percent = (int)data1;

	xtextPersonData2Sub(&sn_head,&sn_tail,p_head);
	result = (char *)xtextSubWindow(disp,main_win,sn_head,sn_tail,percent,0);
	/*
	if(strcmp(result,XJP_CANCEL) == 0) return 1;
	*/

	return 0;
}
int xtextDispCard(void *data0,int data1)
{
	ILIST_T *list;
	sub_window_t *sn_head = NULL, *sn_tail = NULL;
	itext_table_t *table_head = NULL,*table_tail = NULL;
	char *result;
	int percent = 95;

	if(data0 == NULL) return 0;
	if(CARD_FILE == NULL) return 0;
	if(data1 != 0) percent = (int)data1;

	list = (ILIST_T *)data0;

	if(itextGetTableData(&table_head,&table_tail,CARD_FILE,list->save_dir) < 0) return 0;
	xtextCardData2Sub(&sn_head,&sn_tail,table_head);

	if((result = (char *)xtextSubWindow(disp,main_win,sn_head,sn_tail,percent,0)) == NULL){
		_table_data_free(&table_head,&table_tail);
	       	return 0;
	}
	if(strcmp(result,XJP_OK) == 0)
		xtextSubWindow_Message(disp,main_win,XJP_MESSAGE[16]);

	_table_data_free(&table_head,&table_tail);

	return 0;
}
int xtextDispList(void *data0,int data1)
{
	sub_window_t *sn_head = NULL, *sn_tail = NULL;
	ILIST_T *list_head;
	char *result;
	int percent;

	percent = 95;
	list_head = (ILIST_T *)data0;
	if(data1 != 0) percent = (int)data1;

	xtextListData2Sub(&sn_head,&sn_tail,list_head);
	if((result = (char *)xtextSubWindow(disp,main_win,sn_head,sn_tail,percent,0)) == NULL) return 0;
	if(strcmp(result,XJP_OK) != 0) return 0;

	xtextDispCard(list_head,0);

	return 0;
}
int net_win(xtext_conf_t *xconf)
{
	PLIST_T *plist_head = NULL, *plist_tail = NULL;

        if(itextNetBookList(&plist_head,&plist_tail,xconf->book_dir) < 0){
		xtextSubWindow_Message(disp,main_win,XJP_MESSAGE[11]);
		return 1;
	}
	xtextDispPerson((PLIST_T *)plist_head,0);
        plist_data_free(&plist_head,&plist_tail);

        return 1;
}
