#include "ijp_net.h"
#include "xjp_net.h"

extern char *XJP_MESSAGE[];

int xtextPersonData2Sub(sub_window_t **head,sub_window_t **tail,PLIST_T *plist_head)
{
	sub_window_t *sw;
	PLIST_T *pl;
	char temp[128];
	int i;

	if(plist_head == NULL) return -1;
	if(*head != NULL) subwindow_data_free(head,tail);

	subwindow_data_insert(head,tail,T_NAME,NULL,NULL,NULL,NULL,XJP_NONE,XJP_NONE,1);
	subwindow_data_insert(head,tail,"(󥻥 q)",NULL,NULL,xtext_conf_quit,(char *)XJP_CANCEL,XJP_NONE,XJP_NONE,2);

	sprintf(temp,"(ĶꥹȤι) [ %s]",plist_head->file_date);
	subwindow_data_insert(head,tail,temp,NULL,NULL,itext_list_download,NULL,XJP_NONE,XJP_NONE,3);
	subwindow_data_insert(head,tail,"(ñ) [̾ ̾ ϼ̾]",NULL,NULL,xtextSerchList,(PLIST_T *)plist_head,0,XJP_INT,4);

	subwindow_data_insert(head,tail,"-- Ķʸ ȥꥹȡ--",NULL,NULL,NULL,NULL,XJP_NONE,XJP_NONE,5);
	for(pl=plist_head,i=6;pl!=NULL;pl=pl->next,i++){
		sw = (sub_window_t *) subwindow_data_alloc();

		sw->line_str = pl->person;
		sw->line_data = &pl->total;
		sw->re_str = NULL;
		sw->func = xtextDispList;
		sw->func_data0 = pl->list_head;
		sw->func_data1 = 0;
		sw->type = XJP_INT;
		sw->line_no = i;

		subwindow_data_add(head,tail,sw);
	}

	return 0;
}
int xtextCardData2Sub(sub_window_t **head,sub_window_t **tail,itext_table_t *t_head)
{
	itext_table_t *ta,*tr,*td;
	char *p,*pp,str[BUFSIZ];
	int i,j,k,xpad,max,len;

	if(t_head == NULL) return -1;
	if(*head != NULL) subwindow_data_free(head,tail);

	subwindow_data_insert(head,tail,T_NAME,NULL,NULL,NULL,NULL,XJP_NONE,XJP_NONE,1);
	subwindow_data_insert(head,tail,"(󥻥 q)",NULL,NULL,xtext_conf_quit,(char *)XJP_CANCEL,XJP_NONE,XJP_NONE,2);
	subwindow_data_insert(head,tail,"(ο޽)",NULL,NULL,itext_book_download_1,(itext_table_t *)t_head,0,XJP_INT,3);
	subwindow_data_insert(head,tail,"-- Ķʸ ޽񥫡ɡ --",NULL,NULL,NULL,NULL,XJP_NONE,XJP_NONE,4);

	max = 0;
	for(ta=t_head;ta!=NULL;ta=ta->next){
		if(strcmp(ta->name,"ȥǡ") == 0	||
		   strcmp(ta->name,"ʥǡ") == 0		||
		   strcmp(ta->name,"ȥǡ") == 0		||
		   strcmp(ta->name,"ܥǡ") == 0		||
		   strcmp(ta->name,"ǡ") == 0		){

			for(tr=ta->head;tr!=NULL;tr=tr->next){
				for(td=tr->head;td!=NULL;td=td->next){
					if(td->name != NULL){
						len = strlen(td->name);
						if(max < len) max = len; 
						break;
					}
				}
			}
		}
	}

	i = 5;
	for(ta=t_head;ta!=NULL;ta=ta->next){
		if(strcmp(ta->name,"ȥǡ") == 0	||
		   strcmp(ta->name,"ʥǡ") == 0		||
		   strcmp(ta->name,"ȥǡ") == 0		||
		   strcmp(ta->name,"ܥǡ") == 0		||
		   strcmp(ta->name,"ǡ") == 0		){

			for(tr=ta->head;tr!=NULL;tr=tr->next){
				str[0] = '\0';
				xpad = 0;
				for(td=tr->head,j=0;td!=NULL;td=td->next,j++){
					if(td->name == NULL) continue;
					len = strlen(td->name);

					p = NULL;
					if(j == 0){
						xpad = max - len; 
						strcpy(str,td->name);
					}else{
						for(k=0;k<xpad;k++)
							sprintf(str,"%s ",str);

						if((p = strstr(td->name,"")) != NULL){
							*p = '\0';
							sprintf(str,"%s%s",str,td->name);
							subwindow_data_insert(head,tail,str,NULL,NULL,NULL,XJP_CANCEL,XJP_NONE,XJP_NONE,i++);
							pp = p+2;
							while((p=strstr(pp,"")) != NULL){
								*p = '\0';
								str[0] = '\0';
								for(k=0;k<max;k++)
									sprintf(str,"%s ",str);
								sprintf(str,"%s%s",str,pp);
								subwindow_data_insert(head,tail,str,NULL,NULL,NULL,XJP_CANCEL,XJP_NONE,XJP_NONE,i++);
								pp = p+2;
							}
							if(*pp != '\0'){
								str[0] = '\0';
								for(k=0;k<max;k++)
									sprintf(str,"%s ",str);
								sprintf(str,"%s%s",str,pp);
								subwindow_data_insert(head,tail,str,NULL,NULL,NULL,XJP_CANCEL,XJP_NONE,XJP_NONE,i++);
							}
							str[0] = '\0';
						}else{
							sprintf(str,"%s%s",str,td->name);
						}
						xpad = 0;
					}
				}
				if(str[0] != '\0')
					subwindow_data_insert(head,tail,str,NULL,NULL,NULL,XJP_CANCEL,XJP_NONE,XJP_NONE,i++);
			}
		}
	}

	return 0;
}
int xtextListData2Sub(sub_window_t **head,sub_window_t **tail,ILIST_T *l_head)
{
	sub_window_t *sw;
	ILIST_T *il;
	char temp[256];
	int i;

	if(l_head == NULL) return -1;
	if(*head != NULL) subwindow_data_free(head,tail);

	subwindow_data_insert(head,tail,T_NAME,NULL,NULL,NULL,NULL,XJP_NONE,XJP_NONE,1);

	subwindow_data_insert(head,tail,"()",NULL,NULL,xtext_conf_quit,(char *)XJP_CANCEL,XJP_NONE,XJP_NONE,2);

	subwindow_data_insert(head,tail,"-- Ķʸ ʥꥹȡ--",NULL,NULL,NULL,NULL,XJP_NONE,XJP_NONE,3);
	subwindow_data_insert(head,tail,l_head->person,NULL,NULL,NULL,NULL,XJP_NONE,XJP_NONE,4);

	for(il=l_head,i=5;il!=NULL;il=il->next,i++){
		sw = (sub_window_t *)subwindow_data_alloc();
		if(il->person == NULL || il->title == NULL) continue;

		sprintf(temp,"%s %s %s %s",il->stat,il->date,il->type,il->person_i);
		sw->line_data = (char *)malloc(strlen(temp)+2);

		sw->line_str = il->title;
		strcpy(sw->line_data,temp);
		sw->re_str = NULL;
		sw->func = itext_book_download;
		sw->func_data0 = (ILIST_T *)il;
		sw->line_no = i;
		sw->mdata = 1;
		subwindow_data_add(head,tail,sw);
	}

	return 0;
}
